#!/usr/bin/env python
import string, os, threading, time, sys
import interfaces

address=[]
csv, dbName, dbUser, dbPasswd, dbPort, dbAddress, watch, comm=0,0,0,0,0,0,0,0

class TestThread (threading.Thread):
	def run (self):	
		#addr='zaphod.webhop.info'
		addr=address[int(self.getName())].partition('\n')[0]
		dbFileName=csv+addr+'Out.csv'
		if (os.path.exists(csv)==False):
			os.makedirs(csv)
			headline='txbytes	txunicast	txnotunicast	txdiscards	txerrors	rxbytes	rxunicast	rxnotunicast	rxdiscards	rxerrors	unknownprotos	speed	admin_status	oper_status	lastchange	mtu	uptime	date_time	interface	itype	watch_addres\n'
			dbFile=open(dbFileName,'w')
			dbFile.write(headline)
			dbFile.close()
		interfaces.main(addr,comm,dbAddress,dbUser,dbPasswd,dbName,dbFileName)



def loadparam():
	op=open('ip.conf','r')
	line=op.readlines()
	for i in  line:
		if i[0]=='#':
			pass
		else:
			value=i.partition('=')
			if value[0]=='address':
				endPos=0
				startPos=0
				konst=0
				for i in value[2]:	
					partText=value[2]
					if i==';':
						address.append(partText[startPos+konst:endPos])
						startPos=endPos
						konst=1
					endPos=endPos+1
			if value[0]=='community':
				comm=str(value[2]).partition('\n')[0]
			if value[0]=='watchPeriod':
				watch=str(value[2]).partition('\n')[0]
			if value[0]=='dbAddress':
				dbAddress=value[2].partition('\n')[0]
			if value[0]=='dbPort':
				dbPort=str(value[2]).partition('\n')[0]
			if value[0]=='dbName':
				dbName=str(value[2]).partition('\n')[0]
			if value[0]=='dbUser':
				dbUser=str(value[2]).partition('\n')[0]
			if value[0]=='dbPasswd':
				dbPasswd=str(value[2]).partition('\n')[0]
			if value[0]=='csv':
				csv=str(value[2]).partition('\n')[0]
			
	return csv, dbName, dbUser, dbPasswd, dbPort, dbAddress, watch, comm

def main():
	global csv, dbName, dbUser, dbPasswd, dbPort, dbAddress, watch, comm
	#csv, dbName, dbUser, dbPasswd, dbPort, dbAddress, watch, comm= '/home/herbol1/pywatch/','herbol1','herbol1','12345','3306','localhost','5','get_comunity_string'
	csv, dbName, dbUser, dbPasswd, dbPort, dbAddress, watch, comm =loadparam()
	pom =1
	while 1:
		pom =0
		tak=int(time.strftime("%M", time.localtime()))
		time.sleep(1)
		if (tak%int(watch))==0:
			for i in range(len(address)):
				my=TestThread()
				my.setName(i)
				my.start()
			for i in range(len(address)):
				my.join()
			time.sleep(60)
main()
