import sys, array,time
from pysnmp.entity.rfc3413.oneliner import cmdgen
import MySQLdb

start_time, end_time=0,0

admin_stat={'1':'up','2':'down' ,'3':'testing'}
oper_stat={'1':'up','2':'down','3':'testing','4':'unknown','5':'dormant','6':'noPresent','7':'lowerLayerDown'}
iftype={'1':'other(1)', '2':'regular1822(2)','3':'hdh1822(3)', '4':'ddnX25(4)', '5':'rfc877x25(5)', '6':'ethernetCsmacd(6)', '7':'iso88023Csmacd(7)', '8':'iso88024TokenBus(8)', '9':'iso88025TokenRing(9)', '10':'iso88026Man(10)', '11':'starLan(11)', '12':'proteon10Mbit(12)', '13':'proteon80Mbit(13)', '14':'hyperchannel(14)', '15':'fddi(15)', '16':'lapb(16)', '17':'sdlc(17)', '18':'ds1(18)','19':'e1(19)', '20':'basicISDN(20)', '21':'primaryISDN(21)', '22':'propPointToPointSerial(22)', '23':'ppp(23)', '24':'softwareLoopback(24)', '25':'eon(25)', '26':'ethernet3Mbit(26)', '27':'nsip(27)','28':'slip(28)', '29':'ultra(29)', '30':'ds3(30)', '31':'sip(31)', '32':'frameRelay(32)', '33':'rs232(33)', '34':'para(34)', '35':'arcnet(35)', '36':'arcnetPlus(36)', '37':'atm(37)', '38':'miox25(38)', '39':'sonet(39)', '40':'x25ple(40)', '41':'iso88022llc(41)', '42':'localTalk(42)', '43':'smdsDxi(43)', '44':'frameRelayService(44)', '45':'v35(45)', '46h':'ssi(46)', '47':'hippi(47)', '48':'modem(48)', '49':'aal5(49)', '50':'sonetPath(50)', '51':'sonetVT(51)', '52':'smdsIcip(52)', '53':'propVirtual(53)', '54':'propMultiplexor(54)', '55':'ieee80212(55)', '56':'fibreChannel(56)', '57':'hippiInterface(57)', '58':'frameRelayInterconnect(58)', '59':'aflane8023(59)', '60':'aflane8025(60)', '61':'cctEmul(61)', '62':'fastEther(62)', '63':'isdn(63)', '64':'v11(64)', '65':'v36(65)', '66':'g703at64k(66)', '67':'g703at2mb(67)', '68':'qllc(68)', '69':'fastEtherFX(69)', '70':'channel(70)', '71':'ieee80211(71)', '72':'ibm370parChan(72)', '73':'escon(73)', '74':'dlsw(74)', '75':'isdns(75)', '76':'isdnu(76)', '77':'lapd(77)', '78':'ipSwitch(78)', '79':'rsrb(79)', '80':'atmLogical(80)', '81':'ds0(81)', '82':'ds0Bundle(82)', '83':'bsc(83)', '84':'async(84)', '85':'cnr(85)', '86':'iso88025Dtr(86)', '87':'eplrs(87)', '88':'arap(88)', '89':'propCnls(89)', '90':'hostPad(90)', '91':'termPad(91)', '92':'frameRelayMPI(92)', '93':'x213(93)', '94':'adsl(94)', '95':'radsl(95)', '96':'sdsl(96)', '97':'vdsl(97)', '98':'iso88025CRFPInt(98)', '99':'myrinet(99)', '100':'voiceEM(100)', '101':'voiceFXO(101)', '102':'voiceFXS(102)', '103':'voiceEncap(103)', '104':'voiceOverIp(104)', '105':'atmDxi(105)', '106':'atmFuni(106)', '107':'atmIma(107)', '108':'pppMultilinkBundle(108)', '109':'ipOverCdlc(109)', '110':'ipOverClaw(110)', '111':'stackToStack(111)', '112':'virtualIpAddress(112)', '113':'mpc(113)', '114':'ipOverAtm(114)', '115':'iso88025Fiber(115)', '116':'tdlc(116)', '117':'gigabitEthernet(117)', '118':'hdlc(118)', '119':'lapf(119)', '120':'v37(120)', '121':'x25mlp(121)', '122':'x25huntGroup(122)', '123':'trasnpHdlc(123)', '124':'interleave(124)', '125':'fast(125)', '126':'ip(126)', '127':'docsCableMaclayer(127)', '128':'docsCableDownstream(128)', '129':'docsCableUpstream(129)', '130':'a12MppSwitch(130)', '131':'tunnel(131)', '132':'coffee(132)', '133':'ces(133)', '134':'atmSubInterface(134)', '135':'l2vlan(135)', '136':'l3ipvlan(136)', '137':'l3ipxvlan(137)', '138':'digitalPowerline(138)', '139':'mediaMailOverIp(139)', '140':'dtm(140)', '141':'dcn(141)', '142':'ipForward(142)', '143':'msdsl(143)', '144':'ieee1394(144)', '145':'if-gsn(145)', '146':'dvbRccMacLayer(146)', '147':'dvbRccDownstream(147)', '148':'dvbRccUpstream(148)', '149':'atmVirtual(149)', '150':'mplsTunnel(150)', '151':'srp(151)', '152':'voiceOverAtm(152)', '153':'voiceOverFrameRelay(153)', '154':'idsl(154)', '155':'compositeLink(155)', '156':'ss7SigLink(156)', '157':'propWirelessP2P(157)', '158':'frForward(158)', '159':'rfc1483(159)', '160':'usb(160)', '161':'ieee8023adLag(161)', '162':'bgppolicyaccounting(162)', '163':'frf16MfrBundle(163)', '164':'h323Gatekeeper(164)', '165':'h323Proxy(165)', '166':'mpls(166)', '167':'mfSigLink(167)', '168':'hdsl2(168)', '169':'shdsl(169)', '170':'ds1FDL(170)', '171':'pos(171)', '172':'dvbAsiIn(172)', '173':'dvbAsiOut(173)', '174':'plc(174)', '175':'nfas(175)', '176':'tr008(176)', '177':'gr303RDT(177)', '178':'gr303IDT(178)', '179':'isup(179)', '180':'propDocsWirelessMaclayer(180)', '181':'propDocsWirelessDownstream(181)', '182':'propDocsWirelessUpstream(182)', '183':'hiperlan2(183)', '184':'propBWAp2Mp(184)', '185':'sonetOverheadChannel(185)', '186':'digitalWrapperOverheadChannel(186)', '187':'aal2(187)', '188':'radioMAC(188)', '189':'atmRadio(189)', '190':'imt(190)', '191':'mvl(191)', '192':'reachDSL(192)', '193':'frDlciEndPt(193)', '194':'atmVciEndPt(194)', '195':'opticalChannel(195)', '196':'opticalTransport(196)', '197':'propAtm(197)', '198':'voiceOverCable(198)', '199':'infiniband(199)', '200':'teLink(200)', '201':'q2931(201)', '202':'virtualTg(202)', '203':'sipTg(203)', '204':'sipSig(204)', '205':'docsCableUpstreamChannel(205)', '206':'econet(206)', '207':'pon155(207)', '208':'pon622(208)', '209':'bridge(209)', '210':'linegroup(210)', '211':'voiceEMFGD(211)', '212':'voiceFGDEANA(212)', '213':'voiceDID(213)', '214':'mpegTransport(214)', '215':'sixToFour(215)', '216':'gtp(216)', '217':'pdnEtherLoop1(217)', '218':'pdnEtherLoop2(218)', '219':'opticalChannelGroup(219)', '220':'homepna(220)', '221':'gfp(221)', '222':'ciscoISLvlan(222)', '223':'actelisMetaLOOP(223)', '224':'fcipLink(224)', '225':'rpr(225)', '226':'qam(226)', '227':'lmp(227)', '228':'cblVectaStar(228)', '229':'docsCableMCmtsDownstream(229)', '230':'adsl2(230)'}

def storedata_db( send,suni,snuni,sdisc,serr,received,runi,rnuni,rdisc,rerr,unkn,spd,adm,oper,change,mtu,date,interface,itype):
	interface='\''+interface+'\''
	date='\''+date+'\''
	adm='\''+adm+'\''
	oper='\''+oper+'\''
	itype='\''+itype+'\''
	ad='\''+add+'\''
	db = MySQLdb.connect(host=dbA, user=dbU, passwd=dbP, db=dbN)
	cursor=db.cursor()
	cursor.execute("INSERT INTO snmp_data (Txbytes,Txunicast,Txnunicast,Txdiscards,Txerrors,Rxbytes,Rxunicast,Rxnunicast,Rxdiscards,Rxerrors,unknownproto,mtu,tiktak,interface,speed,admin_status,oper_status,iftype,lastchange,watch_address) VALUES (%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%i,%s,%s,%i,%s,%s,%s,%i,%s)" %(send,suni,snuni,sdisc,serr,received,runi,rnuni,rdisc,rerr,unkn,mtu,date,interface,spd,adm,oper,itype,change,ad))
	cursor.close()
	db.commit()
	db.close()
	
def storedata_file(*par):
	
	dbFile=open(cv,'a')
	for i in par:
		dbFile.write(str(i))
		dbFile.write(' ')
	dbFile.write('\n')
	dbFile.close()

def parsedata(varBinds):
	inter_num=varBinds[0]
	inter_num=inter_num[0]
	num=inter_num[1]
	interface_id=(range(num))
	for i in (range(num)):
		pomstr=varBinds[i+1]
		pomstr=pomstr[0]
		num=int(pomstr[1])
		interface_id[i]=num
	#pom=varBinds[5]
	#pom=pom[0]
	#pom=str(pom[0])
	#print pom
	#print pom[len(pom)-2]
	tik=''
	for k in interface_id:
		counter=0
		for i in range(len(varBinds)-1):	
			pom=varBinds[i]
			pom=pom[0]
			pom=str(pom[0])
			pom=pom.strip('()')
			pom= pom[len(pom)-2] +pom[len(pom)-1]
			if int(pom)==k:
				counter=counter+1
				ppom=varBinds[i]
				ppom=ppom[0]
				#print ppom
				ppom=str(ppom[1])
				if counter==2 :
					interface=str(ppom)
				if counter==3 :
					itype=iftype.get(str(ppom))
				if counter==4 :
					mtu=int(ppom)
				if counter==5 :
					speed=int(ppom)
				if counter==7 :
					admin_status=admin_stat.get(str(ppom))
				if counter==8 :
					oper_status=oper_stat.get(str(ppom))
				if counter==9 :
					lastchange=int(ppom)
				if counter==10 :
					rxbytes=int(ppom)
				if counter==11 :
					rxucast=int(ppom)
				if counter==12 :
					rxnucast=int(ppom)
				if counter==13 :
					rxdiscards=int(ppom)
				if counter==14 :
					rxerrors=int(ppom)
				if counter==15 :
					unknownprotos=int(ppom)
				if counter==16 :
					txbytes=int(ppom)
				if counter==17 :
					txucast=int(ppom)
				if counter==18 :
					txnucast=int(ppom)
				if counter==19 :
					txdiscards=int(ppom)
				if counter==20 :
					txerrors=int(ppom)
				if counter==21 :
					outqlen=int(ppom)
		tik = time.strftime("%d.%m.%y %H:%M", time.localtime())
		#storedata_db(txbytes,txucast,txnucast,txdiscards,txerrors,rxbytes,rxucast,rxnucast,rxdiscards,rxerrors,unknownprotos,speed, admin_status,oper_status,lastchange,mtu,tik,interface,itype)
		
		storedata_file(txbytes,txucast,txnucast,txdiscards,txerrors,rxbytes,rxucast,rxnucast,rxdiscards,rxerrors,unknownprotos,speed, admin_status,oper_status,lastchange,mtu,uptime,tik,interface,itype,add)
	return tik
	

def getdata(host,community):
	global uptime
	errorIndication, errorStatus, errorIndex, varBind = cmdgen.CommandGenerator().getCmd(cmdgen.CommunityData('py-watch', community, 1), cmdgen.UdpTransportTarget((host, 161)),(1,3,6,1,2,1,1,3,0))
	if errorIndication == 'requestTimedOut':
		return varBind, errorIndication, errorStatus
	elif errorStatus != 0:	
		return varBind, errorIndication, errorStatus
	varBind=varBind[0]
	uptime=varBind[1]
	errorIndication, errorStatus, errorIndex, varBinds = cmdgen.CommandGenerator().bulkCmd(
	cmdgen.CommunityData('py-watch', community, 1),
	cmdgen.UdpTransportTarget((host, 161)),
	1, 0,# nonRepeaters, maxRepetitions
	(1,3,6,1,2,1,2))
	return varBinds, errorIndication, errorStatus

def main(address,comm,dbAddress,dbUser,dbPasswd,dbName,cvs):
	start_time=time.clock()
	logFile=open('interfaces.log','a')
	tak=time.strftime("%d.%m.%y %H:%M", time.localtime())
	global db, cursor, dbA, dbU, dbP, dbN, add,cv
	dbA, dbU, dbP, dbN=dbAddress,dbUser,dbPasswd,dbName
	add=address
	cv=cvs
	varBinds, errorIndication, errorStatus=getdata(address,comm)
	if errorIndication == 'requestTimedOut':
		log= errorIndication +' '+tak+'\n'
		logFile.write(log)
		logFile.close()
	elif errorStatus != 0:	
		log= errorStatus.prettyPrint +' '+tak+'\n'
		logFile.write(log)
		logFile.close()
	else:
		tak= parsedata(varBinds)
		end_time=time.clock()
		log ='SUCCESS from SECTION \'INTERFACES\' on \''+str(address).upper()+'\' '+tak+' %.2f\n' %(end_time-start_time)
		logFile.write(log)
		logFile.close()
	del dbA, dbU, dbP, dbN,dbAddress,dbUser,dbPasswd,dbName